<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1" />
  <title>Courses CRUD</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <style>
    .container {
      width: 500px;
      margin-top: 50px;
      gap: 20px;
    }

    .select-box {
      display: flex;
      align-items: center;
      gap: 10px;
    }

    .custom {
      width: 200px;
    }
  </style>
</head>

<body >
  <div class="container">
      <div class="form-group row">
        <label for="province" class="col-sm-4 ">Tỉnh, Thành phố:</label>
        <select class="col-sm-8" id="province">
          <option selected>Tỉnh, thành phố</option>
        
        </select>
      </div>
      <div class="form-group row">
        <label for="district" class="col-sm-4 ">Quận, huyện:</label>
        <select class="col-sm-8" id="district">
          <option selected>Quận, huyện</option>
       
        </select>
      </div>
      <div class="form-group row">
        <label for="ward" class="col-sm-4">Phường, Xã:</label>
        <select class="col-sm-8" id="ward">
          <option selected>Phường, xã</option>
      
        </select>
      </div>
  
  </div>


</body>

<script>
const gPROVINCE_LIST = "http://localhost:8080/province-list"; 
const gDISTRICT_LIST= "http://localhost:8080/district-by-provinceId";
const gWARD_LIST = "http://localhost:8080/ward-by-districtId";

class Main {
    constructor() {
        $(document).ready(() => {
            this.pageRender = new RenderPage()
            this.pageRender.renderPage()
        })
    }

}
new Main()
/*** REGION 2 - vùng để render ra bảng*/
class RenderPage {

  constructor() {
    this.vApi = new CallApi()
  }

  _getProvinceList() {
    var self = this;
    this.vApi.onGetProvinceList((paramProvinceList)=> {
    var selectElement = $('#province');

  paramProvinceList.forEach(function(province) {
    var optionElement = $('<option></option>');
    optionElement.val(province.id);
    optionElement.text(province.name);

    selectElement.append(optionElement);
    })
    selectElement.on('change', function() {
      var selectedProvinceId = $(this).val();
      console.log(selectedProvinceId)
      self._getDistrictListByProvince(selectedProvinceId);
    });
  })
  }
  _getDistrictListByProvince(provinceId) {
    var self = this;
    var selectElement = $('#district');
    selectElement.empty();
    var defaultOption = $('<option></option>');
    defaultOption.val('');
    defaultOption.text('Quận, huyện');
    selectElement.append(defaultOption);

    this.vApi.onGetDistrictByProvince(provinceId,(paramDistrictList)=> {
      paramDistrictList.forEach(function(district) {
      var optionElement = $('<option></option>');
      optionElement.val(district.id);
      optionElement.text(district.name);

      selectElement.append(optionElement);
    });
    })

    selectElement.on('change', function() {
    var selectedDistrictId = $(this).val();
    self._getWardByDistrict(selectedDistrictId);
  });
  }
  _getWardByDistrict(districtId) {
    var self = this;
    var selectElement = $('#ward');
    selectElement.empty();
    var defaultOption = $('<option></option>');
    defaultOption.val('');
    defaultOption.text('Phường, xã');
    selectElement.append(defaultOption);

  this.vApi.onGetWardByDistrict(districtId, (paramWardList) => {
    paramWardList.forEach(function(ward) {
      var optionElement = $('<option></option>');
      optionElement.val(ward.id);
      optionElement.text(ward.name);

      selectElement.append(optionElement);
    });
  });
  }
    // Hàm sẽ được gọi ở class Main 
    renderPage() {
        this._getProvinceList()
      
    }
}

/*** REGION 3 - vùng để gọi lên cơ sở dữ liệu lấy đa ta về*/
class CallApi {
    constructor() {

    }
    onGetProvinceList(paramCallbackFn) {
     
        $.ajax({
            url: gPROVINCE_LIST,
            method: "GET",
            success: function (data) {
                paramCallbackFn(data)
            },
            error: function (jqXHR, textStatus, errorThrown) {
               
            }
        });
    }
    onGetDistrictByProvince(provinceId, paramCallbackFn) {
     
     $.ajax({
         url: `${gDISTRICT_LIST}/${provinceId}`,
         method: "GET",
         success: function (data) {
             paramCallbackFn(data)
         },
         error: function (jqXHR, textStatus, errorThrown) {
            
         }
     });
 }

    onGetWardByDistrict(wardId, paramCallbackFn) {
     
     $.ajax({
         url: `${gWARD_LIST}/${wardId}`,
         method: "GET",
         success: function (data) {
             paramCallbackFn(data)
         },
         error: function (jqXHR, textStatus, errorThrown) {
            
         }
     });
 }

}

</script>

</html>
